-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
DischargeableAddon = {} local modName = g_currentModName function getConfigurationsFromXML(xmlFile, superfunc, key, baseDir, customEnvironment, isMod, storeItem) local configurations, defaultConfigurationIds = superfunc(xmlFile, key, baseDir, customEnvironment, isMod, storeItem) if configurations ~= nil and string.match(storeItem.xmlFilename, modName) and string.match(storeItem.rawXMLFilename, "crossplay") then configurations["dischargeableAddon"] = { { isDefault = true, saveId = "1", isSelectable = true, index = 1, dailyUpkeep = 0, price = 0, name = g_i18n:getText("configuration_valueYes"), nameCompareParams = {} }, { isDefault = false, saveId = "2", isSelectable = true, index = 2, dailyUpkeep = 0, name = g_i18n:getText("configuration_valueNo"), price = 0, nameCompareParams = {} } } end return configurations, defaultConfigurationIds end function DischargeableAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(Dischargeable, specializations) and SpecializationUtil.hasSpecialization(Dischargeable, specializations) end function DischargeableAddon.initSpecialization() local name = "dischargeableAddon" if g_configurationManager:getConfigurationDescByName(name) == nil then g_configurationManager:addConfigurationType(name, g_i18n:getText("configuration_dischargeableAddon"), nil, nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION) end StoreItemUtil.getConfigurationsFromXML = Utils.overwrittenFunction(StoreItemUtil.getConfigurationsFromXML, getConfigurationsFromXML) end function DischargeableAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "setDischargeableAddon", DischargeableAddon.setDischargeableAddon) end function DischargeableAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onReadStream", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", DischargeableAddon) SpecializationUtil.registerEventListener(vehicleType, "onPreDetach", DischargeableAddon) end function DischargeableAddon:onLoad(savegame) local spec = self.spec_dischargeable spec.emptySpeed = 0.25 spec.emptySpeedChange = 6 spec.movingDirectionBackup = 0 end function DischargeableAddon:onPostLoad(savegame) local spec = self.spec_dischargeable self:setDischargeableAddon(spec.emptySpeedChange, true) end function DischargeableAddon:onReadStream(streamId, connection) if connection:getIsServer() then local emptySpeedChange = streamReadInt8(streamId) self:setDischargeableAddon(emptySpeedChange, true) end end function DischargeableAddon:onWriteStream(streamId, connection) if not connection:getIsServer() then local spec = self.spec_dischargeable streamWriteInt8(streamId, spec.emptySpeedChange) end end function DischargeableAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_dischargeable if spec.attacherVehicle ~= nil and self.configurations.dischargeableAddon == 1 then if self.movingDirection < 0 and spec.attacherVehicle.movingDirection < 0 and spec.currentDischargeState == 0 then elseif spec.currentDischargeState > 0 and self:getAnimationExists("tipAnimationDoor") then if self:getAnimationTime("tipAnimationDoor") < 1 and self.spec_dischargeable.preferedTipSideIndex == 1 then spec.currentDischargeNode.emptySpeed = spec.emptySpeedChange*(1-self:getAnimationTime("tipAnimationDoor")*0.95) elseif self.spec_dischargeable.preferedTipSideIndex == 1 then if spec.movingDirectionBackup > 0 and self.movingDirection < 1 then spec.movingDirectionBackup = 0 spec.currentDischargeNode.emptySpeed = spec.emptySpeed+self:getAnimationTime("tipAnimationBack")*spec.emptySpeedChange elseif spec.currentDischargeNode.emptySpeed > spec.emptySpeed*self:getAnimationTime("tipAnimationBack") then spec.currentDischargeNode.emptySpeed = spec.currentDischargeNode.emptySpeed-spec.emptySpeedChange*0.01 else spec.currentDischargeNode.emptySpeed = spec.emptySpeed*self:getAnimationTime("tipAnimationBack") end end if self.lastSpeedReal*1000 > 0.36 and self.movingDirection > 0 then spec.movingDirectionBackup = self.movingDirection end else spec.currentDischargeNode.emptySpeed = spec.emptySpeed*spec.emptySpeedChange spec.movingDirectionBackup = 0 end end end function DischargeableAddon:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_dischargeable if  spec.attacherVehicle ~= nil and self.configurations.dischargeableAddon == 1 then if self:getAnimationExists("tipAnimationDoor") then local nameFillType = Utils.getNoNil(g_fillTypeManager:getFillTypeNameByIndex(self:getDischargeFillType(spec.currentDischargeNode)), "unknown") if nameFillType == "CHAFF" or nameFillType == "DRYGRASS" or nameFillType == "DRYGRASS_WINDROW" or nameFillType == "FORAGE" or nameFillType == "FORAGE_MIXING" or nameFillType == "GRASS" or nameFillType == "GRASS_WINDROW" or nameFillType == "MANURE" or nameFillType == "POTATO" or nameFillType == "SILAGE" or nameFillType == "SNOW" or nameFillType == "SORGHUM" or nameFillType == "STONE" or nameFillType == "STRAW" or nameFillType == "SUGARBEET" or nameFillType == "SUGARBEET_CUT" or nameFillType == "WOODCHIPS" then spec.emptySpeedChange = self:getFillUnitCapacity(1)/1000/4 if self.spec_dischargeable.preferedTipSideIndex == 1 then spec.emptySpeed = 0.25 else spec.emptySpeed = 0.6 end else spec.emptySpeedChange = self:getFillUnitCapacity(1)/1000/14 if self.spec_dischargeable.preferedTipSideIndex == 1 then spec.emptySpeed = 1 else spec.emptySpeed = 0.6 end end end self:setDischargeableAddon(spec.emptySpeedChange) end end function DischargeableAddon:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex, loadFromSavegame) local spec = self.spec_dischargeable spec.attacherVehicle = self:getRootVehicle() if spec.attacherVehicle:getMotor().maxBackwardSpeed == nil then spec.attacherVehicle = nil end end function DischargeableAddon:onPreDetach(attacherVehicle, implement) local spec = self.spec_dischargeable spec.attacherVehicle = nil end function DischargeableAddon:setDischargeableAddon(emptySpeedChange, noEventSend) local spec = self.spec_dischargeable DischargeableAddonEvent.sendEvent(self, emptySpeedChange, noEventSend) spec.emptySpeedChange = emptySpeedChange end function DischargeableAddon:updateDebugValues(values) local spec = self.spec_dischargeable if spec.attacherVehicle ~= nil then table.insert(values, {name="emptySpeedChange", value=string.format("%.4f", spec.emptySpeedChange)}) table.insert(values, {name="emptySpeed", value=string.format("%.4f", spec.currentDischargeNode.emptySpeed)}) table.insert(values, {name="lastSpeedReal", value=string.format("%.4f", self.lastSpeedReal*1000)}) table.insert(values, {name="movingDirectionBackup", value=string.format("%.4f", spec.movingDirectionBackup)}) table.insert(values, {name="movingDirection", value=string.format("%.4f", self.movingDirection)}) end end DischargeableAddonEvent = {} local DischargeableAddonEvent_mt = Class(DischargeableAddonEvent, Event) InitEventClass(DischargeableAddonEvent, "DischargeableAddonEvent") function DischargeableAddonEvent:emptyNew() return Event:new(DischargeableAddonEvent_mt) end function DischargeableAddonEvent:new(vehicle, emptySpeedChange) local self = DischargeableAddonEvent:emptyNew() self.vehicle = vehicle self.emptySpeedChange = emptySpeedChange return self end function DischargeableAddonEvent:readStream(streamId, connection) self.vehicle = NetworkUtil.readNodeObject(streamId) self.emptySpeedChange = streamReadInt8(streamId) self:run(connection) end function DischargeableAddonEvent:writeStream(streamId, connection) NetworkUtil.writeNodeObject(streamId, self.vehicle) streamWriteInt8(streamId, self.emptySpeedChange) end function DischargeableAddonEvent:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(self, false, connection, self.vehicle) end if self.vehicle ~= nil and self.vehicle:getIsSynchronized() then self.vehicle:setDischargeableAddon(self.emptySpeedChange, true) end end function DischargeableAddonEvent.sendEvent(vehicle, emptySpeedChange, noEventSend) if vehicle.spec_dischargeable.emptySpeedChange ~= emptySpeedChange and (noEventSend == nil or noEventSend == false) then if g_server ~= nil then g_server:broadcastEvent(DischargeableAddonEvent:new(vehicle, emptySpeedChange), nil, nil, vehicle) else g_client:getServerConnection():sendEvent(DischargeableAddonEvent:new(vehicle, emptySpeedChange)) end end end