-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
GreaseFillUnit = {} local modDirectory = g_currentModDirectory or "unknown" local modGreaseAddonDirectory = g_modsDirectory.."FS22_grease_addon/" or "unknown" function GreaseFillUnit.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(Attachable, specializations) and SpecializationUtil.hasSpecialization(FillUnit, specializations) and SpecializationUtil.hasSpecialization(Cylindered, specializations) and SpecializationUtil.hasSpecialization(Wearable, specializations) end function GreaseFillUnit.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "loadGreaseFillUnitFromXML", GreaseFillUnit.loadGreaseFillUnitFromXML) end function GreaseFillUnit.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", GreaseFillUnit) end function GreaseFillUnit:onLoad(savegame) local greaseFillUnit = 0 for i = 1, #self.spec_fillUnit.fillUnits do if self:getFillUnitAllowsFillType(i, FillType.GREASE) then greaseFillUnit = i end end if greaseFillUnit == 0 then local entryFillUnit = {} local xmlModFile = Utils.getNoNil(XMLFile.loadIfExists("vehicleXml", Utils.getFilename("xmlFilename/mod.xml", modDirectory), Vehicle.xmlSchema), XMLFile.loadIfExists("vehicleXml", Utils.getFilename("xmlFilename/mod.xml", modGreaseAddonDirectory), Vehicle.xmlSchema)) if self:loadGreaseFillUnitFromXML(xmlModFile, string.format("vehicle.fillUnit.fillUnitConfigurations.fillUnitConfiguration(0).fillUnits.fillUnit(0)"), entryFillUnit, #self.spec_fillUnit.fillUnits + 1) then table.insert(self.spec_fillUnit.fillUnits, entryFillUnit) end end end function GreaseFillUnit:loadGreaseFillUnitFromXML(xmlFile, key, entry, index) local spec = self.spec_fillUnit entry.fillUnitIndex = index entry.capacity = xmlFile:getValue(key .. "#capacity", math.huge) entry.defaultCapacity = entry.capacity entry.updateMass = xmlFile:getValue(key .. "#updateMass", true) entry.canBeUnloaded = xmlFile:getValue(key .. "#canBeUnloaded", true) entry.allowFoldingThreshold = xmlFile:getValue(key .. "#allowFoldingThreshold", entry.capacity) entry.needsSaving = true entry.fillLevel = 0 entry.fillLevelSent = 0 entry.fillType = FillType.UNKNOWN entry.fillTypeSent = FillType.UNKNOWN entry.fillTypeToDisplay = FillType.UNKNOWN entry.fillLevelToDisplay = nil entry.lastValidFillType = FillType.UNKNOWN entry.lastValidFillTypeSent = FillType.UNKNOWN if xmlFile:hasProperty(key .. ".exactFillRootNode") then XMLUtil.checkDeprecatedXMLElements(xmlFile, key .. ".exactFillRootNode#index", key .. ".exactFillRootNode#node") entry.exactFillRootNode = xmlFile:getValue(key .. ".exactFillRootNode#node", nil, self.components, self.i3dMappings) if entry.exactFillRootNode ~= nil then if not CollisionFlag.getHasFlagSet(entry.exactFillRootNode, CollisionFlag.FILLABLE) then Logging.xmlWarning(self.xmlFile, "Missing collision mask bit '%d'. Please add this bit to exact fill root node '%s' in '%s'", CollisionFlag.getBit(CollisionFlag.FILLABLE), getName(entry.exactFillRootNode), key) return false end spec.exactFillRootNodeToFillUnit[entry.exactFillRootNode] = entry spec.exactFillRootNodeToExtraDistance[entry.exactFillRootNode] = xmlFile:getValue(key .. ".exactFillRootNode#extraEffectDistance", 0) spec.hasExactFillRootNodes = true else Logging.xmlWarning(self.xmlFile, "ExactFillRootNode not found for fillUnit '%s'!", key) end end XMLUtil.checkDeprecatedXMLElements(xmlFile, key .. ".autoAimTargetNode#index", key .. ".autoAimTargetNode#node") entry.autoAimTarget = { node = xmlFile:getValue(key .. ".autoAimTargetNode#node", nil, self.components, self.i3dMappings) } if entry.autoAimTarget.node ~= nil then entry.autoAimTarget.baseTrans = { getTranslation(entry.autoAimTarget.node) } entry.autoAimTarget.startZ = xmlFile:getValue(key .. ".autoAimTargetNode#startZ") entry.autoAimTarget.endZ = xmlFile:getValue(key .. ".autoAimTargetNode#endZ") entry.autoAimTarget.startPercentage = xmlFile:getValue(key .. ".autoAimTargetNode#startPercentage", 25) / 100 entry.autoAimTarget.invert = xmlFile:getValue(key .. ".autoAimTargetNode#invert", false) if entry.autoAimTarget.startZ ~= nil and entry.autoAimTarget.endZ ~= nil then local startZ = entry.autoAimTarget.startZ if entry.autoAimTarget.invert then startZ = entry.autoAimTarget.endZ end setTranslation(entry.autoAimTarget.node, entry.autoAimTarget.baseTrans[1], entry.autoAimTarget.baseTrans[2], startZ) end end entry.supportedFillTypes = {} local fillTypes = nil local fillTypeCategories = xmlFile:getValue(key .. "#fillTypeCategories") local fillTypeNames = xmlFile:getValue(key .. "#fillTypes") if fillTypeCategories ~= nil and fillTypeNames == nil then fillTypes = g_fillTypeManager:getFillTypesByCategoryNames(fillTypeCategories, "Warning: '" .. self.configFileName .. "' has invalid fillTypeCategory '%s'.") elseif fillTypeCategories == nil and fillTypeNames ~= nil then fillTypes = g_fillTypeManager:getFillTypesByNames(fillTypeNames, "Warning: '" .. self.configFileName .. "' has invalid fillType '%s'.") else Logging.xmlWarning(self.xmlFile, "Missing 'fillTypeCategories' or 'fillTypes' for fillUnit '%s'", key) return false end if fillTypes ~= nil then for _, fillType in pairs(fillTypes) do entry.supportedFillTypes[fillType] = true end end entry.supportedToolTypes = {} for i = 1, g_toolTypeManager:getNumberOfToolTypes() do entry.supportedToolTypes[i] = true end local startFillLevel = xmlFile:getValue(key .. "#startFillLevel") local startFillTypeStr = xmlFile:getValue(key .. "#startFillType") if startFillTypeStr ~= nil then local startFillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(startFillTypeStr) if startFillTypeIndex ~= nil then entry.startFillLevel = startFillLevel entry.startFillTypeIndex = startFillTypeIndex end end entry.fillRootNode = xmlFile:getValue(key .. ".fillRootNode#node", nil, self.components, self.i3dMappings) if entry.fillRootNode == nil then entry.fillRootNode = self.components[1].node end entry.fillMassNode = xmlFile:getValue(key .. ".fillMassNode#node", nil, self.components, self.i3dMappings) local updateFillLevelMass = xmlFile:getValue(key .. "#updateFillLevelMass", true) if entry.fillMassNode == nil and updateFillLevelMass then entry.fillMassNode = self.components[1].node end entry.ignoreFillLimit = xmlFile:getValue(key .. "#ignoreFillLimit", false) entry.synchronizeFillLevel = xmlFile:getValue(key .. "#synchronizeFillLevel", true) entry.synchronizeFullFillLevel = xmlFile:getValue(key .. "#synchronizeFullFillLevel", false) local defaultBits = 16 for startCapacity, bits in pairs(FillUnit.CAPACITY_TO_NETWORK_BITS) do if startCapacity <= entry.capacity then defaultBits = bits end end entry.synchronizationNumBits = xmlFile:getValue(key .. "#synchronizationNumBits", defaultBits) entry.showOnHud = xmlFile:getValue(key .. "#showOnHud", true) entry.showOnInfoHud = xmlFile:getValue(key .. "#showOnInfoHud", true) entry.uiPrecision = xmlFile:getValue(key .. "#uiPrecision", 0) local unitText = xmlFile:getValue(key .. "#unitTextOverride") if unitText ~= nil then entry.unitText = g_i18n:convertText(unitText) end entry.parentUnitOnHud = nil entry.childUnitOnHud = nil entry.blocksAutomatedTrainTravel = xmlFile:getValue(key .. "#blocksAutomatedTrainTravel", false) entry.fillAnimation = xmlFile:getValue(key .. "#fillAnimation") entry.fillAnimationLoadTime = xmlFile:getValue(key .. "#fillAnimationLoadTime") entry.fillAnimationEmptyTime = xmlFile:getValue(key .. "#fillAnimationEmptyTime") entry.fillLevelAnimationName = xmlFile:getValue(key .. ".fillLevelAnimation#name") entry.fillLevelAnimationResetOnEmpty = xmlFile:getValue(key .. ".fillLevelAnimation#resetOnEmpty", true) if self.isClient then entry.alarmTriggers = {} local i = 0 while true do local nodeKey = key .. string.format(".alarmTriggers.alarmTrigger(%d)", i) if not xmlFile:hasProperty(nodeKey) then break end local alarmTrigger = {} if self:loadAlarmTrigger(xmlFile, nodeKey, alarmTrigger, entry) then table.insert(entry.alarmTriggers, alarmTrigger) end i = i + 1 end entry.measurementNodes = {} i = 0 while true do local nodeKey = key .. string.format(".measurementNodes.measurementNode(%d)", i) if not xmlFile:hasProperty(nodeKey) then break end local measurementNode = {} if self:loadMeasurementNode(xmlFile, nodeKey, measurementNode) then table.insert(entry.measurementNodes, measurementNode) end i = i + 1 end entry.fillPlane = {} entry.lastFillPlaneType = nil if not self:loadFillPlane(xmlFile, key .. ".fillPlane", entry.fillPlane, entry) then entry.fillPlane = nil end entry.fillTypeMaterials = self:loadFillTypeMaterials(xmlFile, key) entry.fillEffects = g_effectManager:loadEffect(xmlFile, key .. ".fillEffect", self.components, self, self.i3dMappings) entry.animationNodes = g_animationManager:loadAnimations(xmlFile, key .. ".animationNodes", self.components, self, self.i3dMappings) XMLUtil.checkDeprecatedXMLElements(xmlFile, key .. ".fillLevelHud", key .. ".dashboard") if self.loadDashboardsFromXML ~= nil then self:loadDashboardsFromXML(xmlFile, key, { maxFunc = "capacity", valueFunc = "fillLevel", minFunc = 0, valueTypeToLoad = "fillLevel", valueObject = entry }) self:loadDashboardsFromXML(xmlFile, key, { maxFunc = 100, minFunc = 0, valueTypeToLoad = "fillLevelPct", valueObject = entry, valueFunc = function (fillUnit) return MathUtil.clamp(fillUnit.fillLevel / fillUnit.capacity, 0, 1) * 100 end }) self:loadDashboardsFromXML(xmlFile, key, { maxFunc = "capacity", valueFunc = "fillLevel", minFunc = 0, valueTypeToLoad = "fillLevelWarning", valueObject = entry, additionalAttributesFunc = Dashboard.warningAttributes, stateFunc = Dashboard.warningState }) end end return true end